diff -ruN nginx-1.3.0/src/http/modules/ngx_http_userid_filter_module.c nginx-1.3.0_zls/src/http/modules/ngx_http_userid_filter_module.c
--- nginx-1.3.0/src/http/modules/ngx_http_userid_filter_module.c	2012-02-28 19:31:05.000000000 +0800
+++ nginx-1.3.0_zls/src/http/modules/ngx_http_userid_filter_module.c	2012-05-22 17:09:21.894627743 +0800
@@ -20,6 +20,10 @@
 
 
 typedef struct {
+    ngx_uint_t  reset_index;
+} ngx_http_userid_main_conf_t;
+
+typedef struct {
     ngx_uint_t  enable;
 
     ngx_int_t   service;
@@ -32,7 +36,7 @@
     time_t      expires;
 
     u_char      mark;
-} ngx_http_userid_conf_t;
+} ngx_http_userid_loc_conf_t;
 
 
 typedef struct {
@@ -44,18 +48,19 @@
 
 
 static ngx_http_userid_ctx_t *ngx_http_userid_get_uid(ngx_http_request_t *r,
-    ngx_http_userid_conf_t *conf);
+    ngx_http_userid_loc_conf_t *conf);
 static ngx_int_t ngx_http_userid_variable(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, ngx_str_t *name, uint32_t *uid);
 static ngx_int_t ngx_http_userid_set_uid(ngx_http_request_t *r,
-    ngx_http_userid_ctx_t *ctx, ngx_http_userid_conf_t *conf);
+    ngx_http_userid_ctx_t *ctx, ngx_http_userid_loc_conf_t *conf);
 static ngx_int_t ngx_http_userid_create_uid(ngx_http_request_t *r,
-    ngx_http_userid_ctx_t *ctx, ngx_http_userid_conf_t *conf);
+    ngx_http_userid_ctx_t *ctx, ngx_http_userid_loc_conf_t *conf);
 
+static void *ngx_http_userid_create_main_conf(ngx_conf_t *cf);
 static ngx_int_t ngx_http_userid_add_variables(ngx_conf_t *cf);
 static ngx_int_t ngx_http_userid_init(ngx_conf_t *cf);
-static void *ngx_http_userid_create_conf(ngx_conf_t *cf);
-static char *ngx_http_userid_merge_conf(ngx_conf_t *cf, void *parent,
+static void *ngx_http_userid_create_loc_conf(ngx_conf_t *cf);
+static char *ngx_http_userid_merge_loc_conf(ngx_conf_t *cf, void *parent,
     void *child);
 static char *ngx_http_userid_domain(ngx_conf_t *cf, void *post, void *data);
 static char *ngx_http_userid_path(ngx_conf_t *cf, void *post, void *data);
@@ -100,35 +105,35 @@
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_enum_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, enable),
+      offsetof(ngx_http_userid_loc_conf_t, enable),
       ngx_http_userid_state },
 
     { ngx_string("userid_service"),
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_num_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, service),
+      offsetof(ngx_http_userid_loc_conf_t, service),
       NULL },
 
     { ngx_string("userid_name"),
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_str_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, name),
+      offsetof(ngx_http_userid_loc_conf_t, name),
       NULL },
 
     { ngx_string("userid_domain"),
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_str_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, domain),
+      offsetof(ngx_http_userid_loc_conf_t, domain),
       &ngx_http_userid_domain_p },
 
     { ngx_string("userid_path"),
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_str_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, path),
+      offsetof(ngx_http_userid_loc_conf_t, path),
       &ngx_http_userid_path_p },
 
     { ngx_string("userid_expires"),
@@ -142,7 +147,7 @@
       NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_conf_set_str_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
-      offsetof(ngx_http_userid_conf_t, p3p),
+      offsetof(ngx_http_userid_loc_conf_t, p3p),
       &ngx_http_userid_p3p_p },
 
     { ngx_string("userid_mark"),
@@ -160,14 +165,14 @@
     ngx_http_userid_add_variables,         /* preconfiguration */
     ngx_http_userid_init,                  /* postconfiguration */
 
-    NULL,                                  /* create main configuration */
+    ngx_http_userid_create_main_conf,      /* create main configuration */
     NULL,                                  /* init main configuration */
 
     NULL,                                  /* create server configuration */
     NULL,                                  /* merge server configuration */
 
-    ngx_http_userid_create_conf,           /* create location configuration */
-    ngx_http_userid_merge_conf             /* merge location configuration */
+    ngx_http_userid_create_loc_conf,       /* create location configuration */
+    ngx_http_userid_merge_loc_conf         /* merge location configuration */
 };
 
 
@@ -190,14 +195,13 @@
 static ngx_str_t   ngx_http_userid_got = ngx_string("uid_got");
 static ngx_str_t   ngx_http_userid_set = ngx_string("uid_set");
 static ngx_str_t   ngx_http_userid_reset = ngx_string("uid_reset");
-static ngx_uint_t  ngx_http_userid_reset_index;
 
 
 static ngx_int_t
 ngx_http_userid_filter(ngx_http_request_t *r)
 {
-    ngx_http_userid_ctx_t   *ctx;
-    ngx_http_userid_conf_t  *conf;
+    ngx_http_userid_ctx_t       *ctx;
+    ngx_http_userid_loc_conf_t  *conf;
 
     if (r != r->main) {
         return ngx_http_next_header_filter(r);
@@ -227,8 +231,8 @@
 ngx_http_userid_got_variable(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data)
 {
-    ngx_http_userid_ctx_t   *ctx;
-    ngx_http_userid_conf_t  *conf;
+    ngx_http_userid_ctx_t       *ctx;
+    ngx_http_userid_loc_conf_t  *conf;
 
     conf = ngx_http_get_module_loc_conf(r->main, ngx_http_userid_filter_module);
 
@@ -257,8 +261,8 @@
 ngx_http_userid_set_variable(ngx_http_request_t *r,
     ngx_http_variable_value_t *v, uintptr_t data)
 {
-    ngx_http_userid_ctx_t   *ctx;
-    ngx_http_userid_conf_t  *conf;
+    ngx_http_userid_ctx_t       *ctx;
+    ngx_http_userid_loc_conf_t  *conf;
 
     conf = ngx_http_get_module_loc_conf(r->main, ngx_http_userid_filter_module);
 
@@ -287,7 +291,7 @@
 
 
 static ngx_http_userid_ctx_t *
-ngx_http_userid_get_uid(ngx_http_request_t *r, ngx_http_userid_conf_t *conf)
+ngx_http_userid_get_uid(ngx_http_request_t *r, ngx_http_userid_loc_conf_t *conf)
 {
     ngx_int_t                n;
     ngx_str_t                src, dst;
@@ -358,7 +362,7 @@
 
 static ngx_int_t
 ngx_http_userid_set_uid(ngx_http_request_t *r, ngx_http_userid_ctx_t *ctx,
-    ngx_http_userid_conf_t *conf)
+    ngx_http_userid_loc_conf_t *conf)
 {
     u_char           *cookie, *p;
     size_t            len;
@@ -454,14 +458,15 @@
 
 static ngx_int_t
 ngx_http_userid_create_uid(ngx_http_request_t *r, ngx_http_userid_ctx_t *ctx,
-    ngx_http_userid_conf_t *conf)
+    ngx_http_userid_loc_conf_t *conf)
 {
-    ngx_connection_t           *c;
-    struct sockaddr_in         *sin;
-    ngx_http_variable_value_t  *vv;
+    ngx_connection_t               *c;
+    struct sockaddr_in             *sin;
+    ngx_http_variable_value_t      *vv;
+    ngx_http_userid_main_conf_t    *umcf;
 #if (NGX_HAVE_INET6)
-    u_char                     *p;
-    struct sockaddr_in6        *sin6;
+    u_char                         *p;
+    struct sockaddr_in6            *sin6;
 #endif
 
     if (ctx->uid_set[3] != 0) {
@@ -470,7 +475,9 @@
 
     if (ctx->uid_got[3] != 0) {
 
-        vv = ngx_http_get_indexed_variable(r, ngx_http_userid_reset_index);
+        umcf = ngx_http_get_module_main_conf(r, ngx_http_userid_filter_module);
+
+        vv = ngx_http_get_indexed_variable(r, umcf->reset_index);
 
         if (vv->len == 0 || (vv->len == 1 && vv->data[0] == '0')) {
 
@@ -598,8 +605,9 @@
 static ngx_int_t
 ngx_http_userid_add_variables(ngx_conf_t *cf)
 {
-    ngx_int_t             n;
-    ngx_http_variable_t  *var;
+    ngx_int_t                     n;
+    ngx_http_variable_t          *var;
+    ngx_http_userid_main_conf_t  *umcf;
 
     var = ngx_http_add_variable(cf, &ngx_http_userid_got, 0);
     if (var == NULL) {
@@ -628,18 +636,33 @@
         return NGX_ERROR;
     }
 
-    ngx_http_userid_reset_index = n;
+    umcf = ngx_http_conf_get_module_main_conf(cf,
+            ngx_http_userid_filter_module);
+
+    umcf->reset_index = n;
 
     return NGX_OK;
 }
 
+static void *
+ngx_http_userid_create_main_conf(ngx_conf_t *cf)
+{
+    ngx_http_userid_main_conf_t  *conf;
+
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_userid_main_conf_t));
+    if (conf == NULL) {
+        return NULL;
+    }
+
+    return conf;
+}
 
 static void *
-ngx_http_userid_create_conf(ngx_conf_t *cf)
+ngx_http_userid_create_loc_conf(ngx_conf_t *cf)
 {
-    ngx_http_userid_conf_t  *conf;
+    ngx_http_userid_loc_conf_t  *conf;
 
-    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_userid_conf_t));
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_userid_loc_conf_t));
     if (conf == NULL) {
         return NULL;
     }
@@ -663,10 +686,10 @@
 
 
 static char *
-ngx_http_userid_merge_conf(ngx_conf_t *cf, void *parent, void *child)
+ngx_http_userid_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child)
 {
-    ngx_http_userid_conf_t *prev = parent;
-    ngx_http_userid_conf_t *conf = child;
+    ngx_http_userid_loc_conf_t *prev = parent;
+    ngx_http_userid_loc_conf_t *conf = child;
 
     ngx_conf_merge_uint_value(conf->enable, prev->enable,
                               NGX_HTTP_USERID_OFF);
@@ -753,7 +776,7 @@
 static char *
 ngx_http_userid_expires(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 {
-    ngx_http_userid_conf_t *ucf = conf;
+    ngx_http_userid_loc_conf_t *ucf = conf;
 
     ngx_str_t  *value;
 
@@ -798,7 +821,7 @@
 static char *
 ngx_http_userid_mark(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 {
-    ngx_http_userid_conf_t *ucf = conf;
+    ngx_http_userid_loc_conf_t *ucf = conf;
 
     ngx_str_t  *value;
 